#include <stl.h>
#include <iostream.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>

#define SH_VAR_SET_VALUE 0
#define SH_VAR_GET_VALUE 1
#define SH_VAR_FINALIZE 2
#define SH_VAR_OK 3

struct pscux_info_t{
  size_t sh_var_size;
  int pipe_req[2];
  int pipe_data_in[2];
  int pipe_data_out[2];
  struct flock fl;
};

void *pscuxShVarServer( void *info_ ){
  cout << "\tservidor SH iniciado" << endl;
  pscux_info_t rec_info;
  void *data;
  int req;
  int conf;
  bool loop;

  loop = true;

  rec_info = *(pscux_info_t*)info_;
  
  data = malloc( rec_info.sh_var_size );
  /*  cout << "\tmemoria alocada para o valor: " << rec_info.sh_var_size << endl;

  cout << "\tpipe de requerimentos: ( " << rec_info.pipe_req[0] << " , "
       << rec_info.pipe_req[1] << " )" << endl;
  cout << "\tpipe de entrada de dados: ( " << rec_info.pipe_data_in[0] << " , "
       << rec_info.pipe_data_in[1] << " )" << endl;
  cout << "\tpipe de saida de dados: ( " << rec_info.pipe_data_out[0] << " , "
       << rec_info.pipe_data_out[1] << " )" << endl;
  */
  while(loop){
    read( rec_info.pipe_req[0] , &req , sizeof(req) );
    // manda confirmaao que recebeu o requerimento (sem alterar req claro)
    //sleep(1);
    write( rec_info.pipe_data_out[1] , &conf , sizeof(conf)); 
    switch (req){
    case SH_VAR_SET_VALUE:
      /*  cout << "\trecebi requerimento de set value" << endl; */
      read( rec_info.pipe_data_in[0] , data , rec_info.sh_var_size);
      cout << "\talterei o valor para " << *(int*)data << endl; 
      // manda confirmaao que recebeu
      req = SH_VAR_OK;
      //sleep(1);
      write( rec_info.pipe_data_out[1] , &conf , sizeof(conf)); 
      break;
    case SH_VAR_GET_VALUE:
      /*      cout << "\trecebi requerimento de get value" << endl; */
      write( rec_info.pipe_data_out[1] , data , rec_info.sh_var_size);
      // espera confirmao de recebimento
      read( rec_info.pipe_data_in[0] , &conf , sizeof(conf) );
      /*      cout << "confirmado com status " << conf << endl; */
    
      break;
    case SH_VAR_FINALIZE:
      cout << "\trecebi requerimento de finalize" << endl;
      loop = false;
      break;
    default:
      break;
    }
  }
  
  cout << "\tfinalizando Sh Var Server" << endl;

  //sleep(1);
  pthread_exit(0);
  return NULL;
}


template<class T>
class PscuxSharedVar{
 private:
  T value;
  pscux_info_t info;
  pthread_t thread;
  int req;
  int conf;
 public:
  PscuxSharedVar(){
    // cria thread servidor com o tamanho de T
    info.sh_var_size = sizeof(T);
    pipe(info.pipe_req);
    pipe(info.pipe_data_in);
    pipe(info.pipe_data_out);
    struct flock fl_temp  = { F_WRLCK , SEEK_SET , 0 , 0 , 0 };
    info.fl = fl_temp;
    pthread_create( &thread , NULL , pscuxShVarServer ,  (void*)&info );
  }
  // muda o valor ( depois rescrever o operador de "=")
  void set_value(T valor){
    req = SH_VAR_SET_VALUE;
    
    write( info.pipe_req[1] , &req , sizeof(req) );
    // espera confirmao
    read( info.pipe_data_out[0] , &conf , sizeof(conf) );
    /*    cout << "set value req confirmado com status " << conf << endl; */

    cout << " vou mandar " << valor << endl;
    write( info.pipe_data_in[1] , &valor , sizeof(T) );

    // espera confirmao
    read( info.pipe_data_out[0] , &conf , sizeof(conf) );
    /*    cout << "set value finalizao confirmada com status " << conf << endl; */
  }

  T get_value(){
    req = SH_VAR_GET_VALUE;

    write( info.pipe_req[1] , &req , sizeof(req) );
    // espera confirmao
    read( info.pipe_data_out[0] , &conf , sizeof(conf) );
    /*    cout << "get value req confirmado com status " << conf << endl; */
    
    read( info.pipe_data_out[0] , &value , sizeof(T) );
    // manda confirmao de recebimento do valor
    write( info.pipe_data_in[1] , &conf , sizeof(conf) );
    /*    cout << "get value confirmado com status " << conf << endl; */
    return value;
  }

  void finalize(){
    //manda sinal de finalizaao
    // espera acabar
    req = SH_VAR_FINALIZE;
    write( info.pipe_req[1] , &req , sizeof(req) );
    pthread_join( thread , NULL );
  }
};
