#include <sys/types.h>
#include <sys/wait.h>
#include <pthread.h> /* threads */
#include <unistd.h> /* pipe() */
#include <stl.h> /* templates */

/* main */
template < class INPUT , class OUTPUT >
class Tarefa
{
public:
  typedef struct d_t{
    INPUT data;
    OUTPUT (*func)(INPUT);
    OUTPUT result;
  }data_t;
  
  data_t data;
  pthread_t thread;
  /* construtor */
  Tarefa( OUTPUT (func_)(INPUT) , INPUT data_ ){
    data.data = data_;
    data.func = func_;
    
  }

  /* Faz uma tarefa no cluster retornando imediatamente         *
   * Recebe um ponteiro pra uma funcao e um ponteiro pros dados */
  int exec(){
    if(pthread_create( &thread , NULL , threadFunc , (void*)&data )){
      return -1;
    }else{
      return 0;
    }
  }
  
  /* espera o thread finalizar e retorna o resultado */
  OUTPUT receive(){
    pthread_join( thread , NULL);
    return data.result;
  }

  static void *threadFunc(void *data){
    data_t *d;
    OUTPUT (*funcao)(INPUT);
    
    d = (data_t *)data ;
    funcao = d->func;
    
    int tubo[2];
    int child_pid;
    OUTPUT temp;
    
    pipe(tubo);
    child_pid = fork();
    if(!child_pid){ /* filho */
      /* executa a funcao */
      temp = funcao(d->data); 
      write(tubo[1],&temp,sizeof(OUTPUT));
      exit(0);
    }else{ /* pai */
      /* le do tubo o que seu filho mandou */
      read(tubo[0],&temp, sizeof(OUTPUT));
      
      /* espera a morte de seu esforcado filho */
      waitpid( child_pid, NULL, 0 );
      
      /* retorna o resultado recebido do filho */
    }
    d->result = temp;
  
  pthread_exit( NULL );
  }
};
