#include <sys/types.h>
#include <sys/wait.h>
#include <pthread.h> /* threads */
#include <unistd.h> /* pipe() */
#include <stl.h> /* templates */
#include <fcntl.h>
#include <string.h>
#include "globals.h"

void *pscux_pipe_server_func( void *data );
pscux_tpipe pscux_internal_get_new_tpipe();
void pscux_get_new_pipe( int* p );

pthread_t pipe_server_thread;


typedef struct pscux_pipe_server_req{
  int type;
}pscux_pipe_server_req;

int pscux_pipes[PSCUX_MAX_PROCS][2];
int pscux_pipes_ptr;

int pscux_main_communicator_pipe[2];
int pscux_pipe_server_pipe[2];
int pscux_pipe_server_pipe_back[2];

pscux_tpipe pscux_internal_get_new_tpipe(){
  /* lock 1 */
  pscux_tpipe temp_pipe;
  pipe( pscux_pipes[ pscux_pipes_ptr ] );
  temp_pipe.pipe = pscux_pipes[ pscux_pipes_ptr ];
  cout << "internal_get_new_pipe: generated pipe[0]-> "
       << temp_pipe.pipe[0] << endl
       << "internal_get_new_pipe: generated pipe[1]-> "
       << temp_pipe.pipe[1] << endl;
  pscux_pipes_ptr++;
  /* unlock 1 */
  return temp_pipe;
}


/* servidor de pipes */
void *pscux_pipe_server_func( void *data ){
  pscux_tpipe temp_pipe;
  pscux_pipe_server_req req;
  while( pscux_servers_on ){
    read( pscux_pipe_server_pipe[0] , &req , pscux_sizeof(req) );
    cout << "pipe_server read req-> " << req.type << endl;
    temp_pipe = pscux_internal_get_new_tpipe();
    write( pscux_pipe_server_pipe_back[1] , &temp_pipe , pscux_sizeof(temp_pipe) );
  }
  cout << "pipe_server" << endl;
  pthread_exit( NULL );
}

/* end-user function */
void pscux_get_new_pipe( int* p ){
  pscux_tpipe temp_pipe;
  pscux_pipe_server_req req;

  req.type = 1; /* get_new */
  write( pscux_pipe_server_pipe[1] , &req , pscux_sizeof(req) );
  read( pscux_pipe_server_pipe_back[0] , &temp_pipe , pscux_sizeof(temp_pipe) );
  memcpy( p , temp_pipe.pipe , pscux_sizeof(temp_pipe) );
}
