#include <stl.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
//#include "globals.h"
//#include "mutex.h"

class pscux_mutex{
 public:
  int associated_pipe[2];
  struct flock fl;

  pscux_mutex(){
    pscux_tpipe temp_pipe;
    temp_pipe = pscux_internal_get_new_tpipe();
    associated_pipe = temp_pipe.pipe;
    //pipe( associated_pipe );
    struct flock fl_temp = {  F_WRLCK, SEEK_SET, 0,       0,     0 };
    fl = fl_temp;
  }
  void lock(){
    cout << "trying to lock: " << associated_pipe[1] << endl;
    fl.l_pid = getpid();
    fcntl(associated_pipe[1], F_SETLKW, &fl);
  }
  void unlock(){
    cout << "trying to unlock: " << associated_pipe[1] << endl;
    fl.l_pid = getpid();
    fl.l_type = F_UNLCK;
    fcntl(associated_pipe[1], F_SETLK, &fl);
  }
};


#define PSCUX_MAX_SH_VARS 10

typedef struct pscux_sh_var_server_req{
  int type;
  int pos; /* qual pos alterar */
}pscux_sh_var_server_req;

typedef struct pscux_generic_t{
  void *value;
  size_t size;
}pscux_generic_t;

int pscux_sh_var_server_pipe[2];
int pscux_sh_var_server_pipe_back[2];

int global_sh_var_pos=0;

class Psh_vars{
 public:
  pscux_generic_t sh_vars[PSCUX_MAX_SH_VARS];
  int sh_vars_ptr;

  Psh_vars(){
    sh_vars_ptr = 0;
  }

  template< class T >
    void set_value( int pos , T& new_value ){
    /* pode dar warning em diferenca de tamanho e erro em out_of_range */
    free( sh_vars[pos].value );

    sh_vars[ pos ].value = malloc( pscux_sizeof(new_value) );
    sh_vars[ pos ].size = pscux_sizeof(new_value) ;

    memcpy( sh_vars[pos].value , (void*)&new_value , pscux_sizeof(new_value) );
  }
  
  void gset_value( int pos , pscux_generic_t& g ){
    free( sh_vars[pos].value );
     
    sh_vars[ pos ].value = malloc( g.size );
    sh_vars[ pos ].size = g.size ;

    memcpy( sh_vars[pos].value , (void*)&g.value , g.size );
  }
  
  template< class T >
    void get_value( int pos , T* dest ){
    /* same warnings maybe */
    memcpy( (void*)dest , sh_vars[pos].value , sh_vars[pos].size );
  }
  
  void gget_value( int pos , pscux_generic_t& dest ){
    memcpy( dest.value , sh_vars[pos].value , sh_vars[pos].size );
    memcpy( (void*)&dest.size ,  (void*)&sh_vars[pos].size , pscux_sizeof(sh_vars[pos].size) );
  }

  template< class T >
    void add_new( T& value ){
    sh_vars[ sh_vars_ptr ].value = malloc( sizeof(T) );
    sh_vars[ sh_vars_ptr ].size = sizeof(T) ;

    memcpy( sh_vars[sh_vars_ptr].value , (void*)&value , pscux_sizeof(value) );
    sh_vars_ptr++;
  }

  void gadd_new( pscux_generic_t g ){
    sh_vars[ sh_vars_ptr ].value = malloc( g.size );
    sh_vars[ sh_vars_ptr ].size = g.size ;

    memcpy( sh_vars[sh_vars_ptr].value , (void*)&g.value , g.size );
    sh_vars_ptr++;
  }
};

/* servidor de transaes */
void *pscux_sh_var_server_func( void *data ){
  Psh_vars shared_vars;  
  pscux_sh_var_server_req req;
  pscux_generic_t generic_temp;
  int pos;
  size_t size;

  pipe( pscux_sh_var_server_pipe );
  pipe( pscux_sh_var_server_pipe_back );

  while( pscux_servers_on ){
    /* se no der certo com o servers_on fazer com um valor do req */
    read( pscux_sh_var_server_pipe[0] , &req , pscux_sizeof(req) );
    pos = req.pos;

    if(req.type == 1){
      /* add_new */
      read( pscux_sh_var_server_pipe[0] , &size , pscux_sizeof(size) );
      generic_temp.value = malloc(size);
      generic_temp.size = size;
      read( pscux_sh_var_server_pipe[0] , generic_temp.value , pscux_sizeof(size) );
      shared_vars.gadd_new( generic_temp );
    }else if(req.type == 2){
      /* set_value */
      read( pscux_sh_var_server_pipe[0] , &size , pscux_sizeof(size) );
      generic_temp.value = malloc(size);
      generic_temp.size = size;
      read( pscux_sh_var_server_pipe[0] , generic_temp.value , pscux_sizeof(size) );
      shared_vars.gset_value( pos , generic_temp );
    }else if(req.type == 3){
      /* get_value */
      read( pscux_sh_var_server_pipe[0] , &size , pscux_sizeof(size) );
      generic_temp.value = malloc(size);
      generic_temp.size = size;
      shared_vars.gget_value( pos , generic_temp );
      write( pscux_sh_var_server_pipe_back[1] , &generic_temp , size );
    }
    free(generic_temp.value);
  }     
  pthread_exit( NULL );
}

/* definio de uma variavel compartilhada */
template< class T >
class pscux_shared_var{
 public:
  int position;
  pscux_mutex mutex;
  pscux_sh_var_server_req req;
  size_t size;  
  
  pscux_shared_var(){
    /* call add new trougth reads and writes */
    position = global_sh_var_pos++;
    T temp;
    size = sizeof(temp);
    cout << "pos: " << position << endl;
    req.type = 1; /* add new */
    req.pos = position;
    mutex.lock();
    write( pscux_sh_var_server_pipe[1] , (void*)&req , sizeof(req) );
    write( pscux_sh_var_server_pipe[1] , &size , sizeof(size_t) );
    write( pscux_sh_var_server_pipe[1] , &temp , sizeof(temp) );
    mutex.unlock();
  }

  void set_value( T& new_value ){
    size = sizeof(new_value);
    req.type = 2;
    req.pos = position;
    mutex.lock();
    write( pscux_sh_var_server_pipe[1] , (void*)&req , sizeof(req) );
    write( pscux_sh_var_server_pipe[1] , sizeof(new_value) , sizeof(size_t) );
    write( pscux_sh_var_server_pipe[1] , &new_value , sizeof(new_value) );
    mutex.unlock();
  }

  void get_value( T* dest ){
    req.type = 3;
    req.pos = position;
    mutex.lock();
    write( pscux_sh_var_server_pipe[1] , (void*)&req , sizeof(req) );
    write( pscux_sh_var_server_pipe[1] , pscux_sizeof(dest) , sizeof(size_t) );
    read( pscux_sh_var_server_pipe_back[0] , dest , sizeof(T) );
    mutex.unlock();
  }
};
